/* This file (compat.h) tries to make this source compilable
   regardless of what version (within certain limits, i.e. close to
   the 0.3.6 mark) of e2compr the system header files are patched
   with.

   Note that this program isn't (yet) intended to be _run_ in a 0.4.x
   environment.  (For one thing, the file formats are different.)
   That said, it should be reasonable to run e2decompress under a
   0.4.x kernel just as it is possible under a kernel without e2compr
   support.  */

#ifdef EXT2_COMPRESS_MAGIC_03X
/* Kernel headers are e2compr-0.4.2 or later. */
#elif defined(EXT2_COMPRESS_MAGIC)
# ifdef EXT2_OLD_COMPRESS_MAGIC
/* Kernel headers are e2compr-0.4.{0|1}. */
#  define EXT2_COMPRESS_MAGIC_03X EXT2_OLD_COMPRESS_MAGIC
#  define ext2_cluster_head_03x ext2_old_cluster_head
# else
/* Kernel headers are e2compr but before 0.4. */
#  define EXT2_COMPRESS_MAGIC_03X EXT2_COMPRESS_MAGIC
#  define ext2_cluster_head_03x ext2_cluster_head
# endif
#else
/* Kernel headers are not e2compr. */
# error "System header files appear not to be e2compr-patched.  Edit the Makefile and change the definition of LINUXSRC to be the path of a kernel tree with e2compr patches applied."
#endif
#if EXT2_COMPRESS_MAGIC_03X != 0x8ec7
# error "Incompatible definitions.  Either you have hacked versions of header files, or Peter made a mistake."
#endif

/* These are defined in <linux/ext2_fs.h> for e2compr-0.3.x. */
#define EXT2_LZV1_ID	0x00
#define EXT2_LZV2_ID	0x01
#define EXT2_NONE_ID	0x02
#define EXT2_BZIP2_ID	0x04
#define EXT2_LZRW3A_ID	0x08
#define EXT2_GZIP1_ID	0x10
#define EXT2_GZIP2_ID	0x11
#define EXT2_GZIP3_ID	0x12
#define EXT2_GZIP4_ID	0x13
#define EXT2_GZIP5_ID	0x14
#define EXT2_GZIP6_ID	0x15
#define EXT2_GZIP7_ID	0x16
#define EXT2_GZIP8_ID	0x17
#define EXT2_GZIP9_ID	0x18

#ifndef MAP_FAILED  /* Linux doesn't define this. */
# define MAP_FAILED ((void *) (-1))
#endif
