
#include <stdlib.h>
#include <stdio.h>

#include "lib_bzip.h"

static unsigned char inbuf[32768];
static unsigned char zbuf[40000];
static unsigned char outbuf[32768];

int main ( int argc, char** argv )
{
   int j, k, diffpos;
   int totIn, totOut;
   size_t i, x;

   /* Allocate work area and pass to bzip_init(). */
   {
      size_t required;
      void *work_area;

      required = bzip_init( NULL );
#if 1
      fprintf( stderr, "work area size = %u\n", required );
#endif
      work_area = malloc(required);
      if (work_area == NULL) {
	 fprintf( stderr, "Couldn't allocate %u bytes for work area.\n",
		  required );
	 return 1;
      }
      bzip_init( work_area );
   }

   totIn = totOut = 0;
   while (1) {
      i = fread ( inbuf, 1, 32768, stdin );
      if (i == 0) break;

      j = bzip_compressBlock   ( 
             inbuf, zbuf, i, 34000 /* 31744 */, 0 /*irrel*/ 
          );

      totIn += i;
      totOut += (j ? j : 32768);
      if (j == 0) {
	 fprintf ( stderr, "[%-7d -> %-7d]      ", totIn, totOut );
         fprintf ( stderr, "incompressible block\n" );
      } else {
         k = bzip_uncompressBlock ( 
                zbuf, outbuf, 0 /*irrel*/, 0 /*irrel*/, 0 /*irrel*/ 
             );
         diffpos = -1;
         for (x = 0; x < i; x++)
            if (inbuf[x] != outbuf[x]) { 
            diffpos = x;
            break;
         }
         if (diffpos == -1) {
            fprintf ( stderr, "[%-7d -> %-7d]      %u -> %d\n", 
                              totIn, totOut, i, j );
         } else {
            fprintf ( stderr, "different at %d\n", diffpos );
            return 1;
         }
      }
   }
   return 0;
}
